#!/bin/ash
# jamesbond 2012 - set hostname
APPTITLE="Set Hostname"

[ $(id -u) -ne 0 ] && exec gtksu "$APPTITLE" "$0" "$@"

if Xdialog --title "Warning!" --yesno "Changing hostname will automatically restart X server.
Do you wish to continue?" 0 0; then
	if NEW_HOSTNAME=$(Xdialog --title "$APPTITLE" --backtitle "The current hostname is '$(hostname)'." --stdout \
	--inputbox "Please enter the new hostname." 0 0); then
		NEW_HOSTNAME=$(echo "$NEW_HOSTNAME" | tr -d ' \t\n.~!@#$%^&*()?<>/,;:"[]{}\|=') # remove evil characters
		Xdialog --title "Success!" --infobox "Hostname will be changed to '$NEW_HOSTNAME'. 
X server will be restarted now, but the new hostname will only take full effect after reboot."	0 0 10000
		echo $NEW_HOSTNAME > /etc/hostname
		sed -i'' -e "1 {s/^.*$/127.0.0.1 localhost $(cat /etc/hostname)/}" /etc/hosts 
		hostname -F /etc/hostname
		wmexit restart
	fi
fi
Xdialog --title "Cancelled!" --infobox "Nothing is changed, hostname stays as '$(hostname)'" 0 0 10000
