#!/bin/dash
# jamesbond 2013
# configure hwclock in UTC or in localtime

### config
APPTITLE="Hardware Clock Configuration"
HWCLOCKPARM="--localtime" # default
HWCLOCKCONF=/etc/hwclock.conf
[ -e $HWCLOCKCONF ] && . $HWCLOCKCONF # HWCLOCKPARM, HWCLOCKRTC

### main
[ $(id -u) -ne 0 ] && gtksu "$APPTITLE" "$0"

DEFAULTLOCAL=off DEFAULTUTC=off
case $HWCLOCKPARM in
	*utc) DEFAULTUTC=on ;;
	*localtime) DEFAULTLOCAL=on ;;
esac

if HWCLOCKPARM=$(Xdialog --title "$APPTITLE" --no-tags --stdout \
	--radiolist "Hardware clock keeps timekeeping when your computer is turned off.
	In which timezone do you want to run your hardware clock?" 0 0 0 \
	utc 'UTC (Universal Time) - compatible other Linuxes' $DEFAULTUTC \
	localtime 'Local timezone - compatible with Windows' $DEFAULTLOCAL); then
	echo "HWCLOCKPARM='--${HWCLOCKPARM}' HWCLOCKRTC='$HWCLOCKRTC'" > $HWCLOCKCONF
	hwclock --systohc --$HWCLOCKPARM $HWCLOCKRTC
	Xdialog --title "$APPTITLE" --infobox "Hardware clock now configured to run in '$HWCLOCKPARM'." 0 0 10000
else
	Xdialog --title "Cancelled" --infobox "Nothing was changed." 0 0 10000
fi
